Version française
Home     About     Download     Resources     Contact us    
Browse thread
[Caml-list] DBM in OCaml 3.07
[ Home ] [ Index: by date | by threads ]
[ Search: ]

[ Message by date: previous | next ] [ Message in thread: previous | next ] [ Thread: previous | next ]
Date: -- (:)
From: Matt Gushee <matt@g...>
Subject: [Caml-list] DBM in OCaml 3.07
Hello, all--

I built and installed OCaml 3.07 for the first time yesterday, and
noticed a couple of issues with the Dbm module. First of all, when I ran 
'configure', I got an error message saying that NDBM support was not
available. Now, strictly speaking that is true: I am running Debian
GNU/Linux 3.0 with GDBM, not NDBM. But I had DBM working under OCaml
3.06, and as far as I can remember no special measures were required to
build it.

More specifically, the configure script tests for the existence of
$INCLUDE_PATH/gdbm-ndbm.h; if that file is found, it then tests
'sh ./hasgot -lgdbm_compat -lgdbm dbm_open' (line 1253). This test fails
on my system, since there is no libgdbm_compat.so, and as far as I can 
tell there is no Debian package that provides that library (nor is there
any Debian package providing NDBM--the alternatives to GDBM are packages
called 'libdb2' and 'libdb3'--I haven't tried either, but judging from
the file names in the packages, they aren't intended to be used in place
of NDBM).

Now, I was able to configure and build the Dbm module simply by adding
the lines

  elif sh ./hasgot -lgdbm dbm_open; then
    dbm_link="-lgdbm"

to the configure script, and I seem to have a working Dbm module ... or
do I? I notice I can't open a DBM database in write-only mode, which was
also the case with OCaml 3.06. So I'm wondering if the build was
supposed to fail. 

So I don't know if the configure script needs to be fixed or not. If
not, though, there should probably be some documentation explaining
exactly what libraries and headers are needed for DBM.

The second issue I encountered is that the databases produced by the
3.07 version of Dbm are incompatible with those created under 3.06. E.g.

  $ file /var/lib/fontdb/ttf.db  # old file, created under 3.06
  /var/lib/fontdb/ttf.db: Berkeley DB 1.85 \
    (Hash, version 2, native byte-order)

  $ file /var/tmp/spam.dir       # new files, created under 3.07
  /var/tmp/spam.dir: GNU dbm 1.x or ndbm database, little endian
  $ file /var/tmp/spam.pag 
  /var/tmp/spam.pag: GNU dbm 1.x or ndbm database, little endian
  
Shouldn't there be at least a Changelog entry for this?
      
-- 
Matt Gushee                 When a nation follows the Way,
Englewood, Colorado, USA    Horses bear manure through
mgushee@havenrock.com           its fields;
http://www.havenrock.com/   When a nation ignores the Way,
                            Horses bear soldiers through
                                its streets.
                                
                            --Lao Tzu (Peter Merel, trans.)

-------------------
To unsubscribe, mail caml-list-request@inria.fr Archives: http://caml.inria.fr
Bug reports: http://caml.inria.fr/bin/caml-bugs FAQ: http://caml.inria.fr/FAQ/
Beginner's list: http://groups.yahoo.com/group/ocaml_beginners